<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OXFkType StructType
 * @subpackage Structs
 */
class OXFkType extends AbstractStructBase
{
    /**
     * The skip
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $skip;
    /**
     * The first
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $first;
    /**
     * Constructor method for OXFkType
     * @uses OXFkType::setSkip()
     * @uses OXFkType::setFirst()
     * @param int $skip
     * @param int $first
     */
    public function __construct($skip = null, $first = null)
    {
        $this
            ->setSkip($skip)
            ->setFirst($first);
    }
    /**
     * Get skip value
     * @return int|null
     */
    public function getSkip()
    {
        return $this->skip;
    }
    /**
     * Set skip value
     * @param int $skip
     * @return OXFkType
     */
    public function setSkip($skip = null)
    {
        // validation for constraint: int
        if (!is_null($skip) && !is_numeric($skip)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($skip)), __LINE__);
        }
        $this->skip = $skip;
        return $this;
    }
    /**
     * Get first value
     * @return int|null
     */
    public function getFirst()
    {
        return $this->first;
    }
    /**
     * Set first value
     * @param int $first
     * @return OXFkType
     */
    public function setFirst($first = null)
    {
        // validation for constraint: int
        if (!is_null($first) && !is_numeric($first)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($first)), __LINE__);
        }
        $this->first = $first;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return OXFkType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
